package com.number.utils;
import com.number.model.SAngleed;
import com.number.model.SDevice;
import com.number.model.SDeviceExample;
import com.number.service.SAngleedService;
import com.number.service.SDeriveService;
import com.number.transform.ChnageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import java.net.ServerSocket;
import java.net.Socket;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * @author Larry
 * @date 2021/9/18 10:23
 */
@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
public class SocketServerOne {
    @Autowired
    private ChnageService chnageService;
    @Autowired
    private ServerSocket serverSocket;
    @Autowired
    private SDeriveService sDeriveService;
    @Autowired
    private SAngleedService sAngleedService;

    //3.添加定时任务
    @Scheduled(cron = "0 */10 * * * ?")
    //或直接指定时间间隔，例如：5秒
    //@Scheduled(fixedRate=5000)
    private void configureTasks() throws Exception {
        System.err.println("执行静态定时任务时间: " + LocalDateTime.now());
        monitorStart("sbCode");
    }

    public void monitorStart(String sbCode) throws Exception {
        SDevice sDevice = new SDevice();
        //新建socket服务端 设置端口(该端口是机器内协定端口)
        /*ServerSocket ss = new ServerSocket(9777);
        Socket socket =new Socket();*/
        //accept函数主要用于服务器端 默认阻塞 等待
        //Socket socket = ss.accept();
        //创建一个子线程，处理客户端输入数据  调用run();去干活
        Socket socket = null;
        while (true) {
            serverSocket.setSoTimeout(10000);
            //socket accept() 阻塞 等待介入
            socket = serverSocket.accept();
            //返回设备ID
            String sIds = SocketUtils.sendRequest(socket, "680A000000000321F100992D16");
            String sId = sIds.substring(30, 41);
            //首先去查询数据库是否存在该设备id，存在则不添加
            Map<String, Object> sDeviceMap = sDeriveService.selectsId(sId);
            //判断map是否为空 isEmpty为true则为空
            String sDStr = sDeviceMap.get("sDeviceList").toString();
            if (sDStr.equals("[]")) {
                //将询问机器返回的机器ID添加数据库
                sDevice.setsId(sId);
                sDeriveService.insert(sDevice);
            }
            //开启一个线程
            ClientHandler handler = new ClientHandler(socket, sId);
            Thread t = new Thread(handler);
            t.start();
            break;
        }
    }

    //创建一个子线程接收客户端的数据
    private class ClientHandler implements Runnable {
        private Socket socket;
        private String sId;

        public ClientHandler(Socket socket, String sId) {
            this.socket = socket;
            this.sId = sId;
        }

        @Override
        public void run() {
            //开始扫描
            try {
                scanBegin(socket, sId);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public void scanBegin(Socket socket, String sId) throws Exception{
        //通过设备sId查询该仓房的直径和设备距离仓底的高度
        StringBuffer stringBuffer = new StringBuffer();
        //判断map是否为空 如果为空则生成扫描指令 添加数据库
        Map<String, Object> sAngleedMap = sAngleedService.selectsId(sId);
        String sAStr = sAngleedMap.get("sAngleedList").toString();
        //等于空的情况下说明没有改设备的转动命令，就去生成
        if (sAStr.equals("[]")) {
            System.out.println("***************");
            Map<String, Object> sDeviceMap = sDeriveService.selectsId(sId);
            for (Map.Entry<String, Object> entry : sDeviceMap.entrySet()) {
                List<SDevice> list = (List<SDevice>) entry.getValue();
                for (int i = 0; i < list.size(); i++) {
                    SDevice s = (SDevice) list.get(i);
                    //调用圆仓转动的角度  生成预转动角度
                    stringBuffer = circleUtil.circleOrders(sId, s.getsDiam(), s.getsHigh());
                    String str = new String(stringBuffer);
                    sAngleedService.factAngle(str, sId);
                }
            }
            //如果不为空，则从数据库中取数据，去执行操作
        } else {
            //通过判断for循环 一次执行20条命令
            Map<String, Object> sAMap = sAngleedService.selectsId(sId);
            for (Map.Entry<String, Object> entry : sAMap.entrySet()) {
                List<SAngleed> list = (List<SAngleed>) entry.getValue();
                for (int i1 = 0; i1 < list.size();) {
                    StringBuilder stringBuilder = new StringBuilder();
                        for (int i2 = 0; i2 < 20; i2++) {
                            SAngleed sA = (SAngleed) list.get(i1);
                            i1++;
                            stringBuilder.append(sA.getDegreeX());
                            stringBuilder.append(" ");
                            stringBuilder.append(sA.getDegreeY());
                            stringBuilder.append(",");
                        }
                        String strip20 = new String(stringBuilder);
                        strip20 = strip20.substring(0,strip20.length()-1);
                        String orderStr = chnageService.orderJoint(sId,strip20);
                        String sIdsssss = SocketUtils.sendRequest(socket, orderStr);
                        System.out.println("&&&&&&&"+sIdsssss);
                    }
                }
            }
        }
    }
